/* 
http://StartCd.narod.ru 
 
  rc5  ,    . 
*/

#include <avr\io.h>               // Most basic include files
#include <avr\interrupt.h>       // Add the necessary ones
#include <stdlib.h>       		// Add the necessary ones

//define F_CPU  1000000
#include <util/delay.h> 

#define TIME_P		1.778
#define TIME_TLOW	TIME_P/2
#define TIME_FAULT	0.5

#define P_1	PORTB=1
#define P_0	PORTB=0
//                            	   1   2   3   4   5    6   7   8   9   10  11   12  13  14
const uint8_t komand[][14]=	{    { 1 , 1 , 1 , 1 , 1 , 0 , 0 , 1 , 1  , 1 , 1 , 0 , 1 , 1},
								 { 1 , 1 , 1 , 1 , 1 , 1 , 0 , 1 , 1  , 1 , 1 , 1 , 1 , 1},
								 { 1 , 1 , 0 , 0 , 0 , 0 , 0 , 1 , 0  , 1 , 1 , 1 , 1 , 1},
								 { 1 , 1 , 0 , 1 , 0 , 1 , 0 , 1 , 0  , 1 , 0 , 1 , 0 , 1},
								 { 1 , 1 , 0 , 0 , 0 , 0 , 0 , 0 , 0  , 0 , 0 , 0 , 0 , 0},
								 { 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1  , 1 , 1 , 1 , 1 , 1},
								 { 1 , 1 , 0 , 1 , 0 , 0 , 0 , 1 , 0  , 1 , 1 , 0 , 1 , 1}};
//------------------UART------------------------------------
void USART_Init( void )
{
/* Set baud rate */
	//UBRRH = (unsigned char)(baud>>8);
	UBRRL = 12;//4800
	UCSRB = (1<<TXEN);//(1<<RXEN)||(1<<RXCIE);///* Enable receiver and transmitter */
	UCSRC = (1<<URSEL)|(1<<USBS)|(3<<UCSZ0);/* Set frame format: 8data, 2stop bit */
}

void USART_Transmit( unsigned char data )
{
	//UCSRB|=_BV(TXEN);
/* Wait for empty transmit buffer */
	while ( !( UCSRA & (1<<UDRE)) )
	;
	UDR = data;
}

void puts_uart(uint8_t *str){
while (*str) USART_Transmit(*(str++));
}
//------------------UART------------------------------------

int main(void){
uint8_t  j=0, i, buffer[5];
uint8_t count=0;
	USART_Init();
	DDRB=0xFF;
	PORTA=0xFF;
	
	
while(1){
P_1;
if ((PINA&1)==0)
	{
	while((PINA&1)==0);
	
	puts_uart("puts ");
	itoa(count++, buffer, 10);
	puts_uart(buffer);
	USART_Transmit('\r');				
	
	

	for(i=0; i<14; i++){
		if (komand[j][i]==1)
			{
			P_1;
			_delay_ms(TIME_TLOW);
			P_0;
			_delay_ms(TIME_TLOW);
			}else{
			P_0;
			_delay_ms(TIME_TLOW);
			P_1;
			_delay_ms(TIME_TLOW);
			//       11   
			if ( (PINA&_BV(1))==0 ) if (i==10) _delay_ms(TIME_FAULT); 
			}
			
		}
	if (++j==7) j=0;
	}

}	
}






